{ 
  -= Module CPU =-

  Project: CaraaraC 2
  Programmed by: Marcelo Silveira
  E-mail: flamar98@hotmail.com
  Date: November 2018
  License: GNU-GPL, v. 3.x

  Constantes e variáveis
  cpu_found - Flag que diz se o CPU achou o personagem do jogador.
  cpu_pers - Guarda o número de personagens restantes do computador.

  Procedures e Functions
  _remove_unique_chars - Remove das perguntas as características únicas por categoria.
  _check_avail_char - Verifica as características restantes, de acordo com os personagens não marcados.
  _mark_pers_risk - Descarta o personagem isoladamente.
  _mark_pers - Descarta personagens de acordo com a pergunta feita.
  _cpu_risk_pers - O computador arrisca um personagem.
  _ask_player - Pergunta ao jogador.
  cpu_found_char - Retorna se o CPU achou o personagem do jogador.
  cpu_reveal - Revela o personagem do computador. Retorna string.
  cpu_play - O CPU joga.
  cpu_choose_pers - Escolhe aleatoriamente um personagem.
}

var cpu_found : boolean;
    cpu_pers : byte;


{ Private }

procedure _remove_unique_chars;
var tmp : array[1..10] of byte;
    i, j, c : byte;
begin
  i:=0;

  { Count }
  for j:=1 to 25 do
  begin
    if (tipo_map[j] = 1) then
    begin
      if (i>0) then tmp[i] := c;
      i:=i+1;
      c:=0;
    end;
    if (menu_asked[j,2] = false) then c:=c+1;
  end;

  { Mark all, if tmp[n]=1 }
  for j:=1 to 24 do
  begin
    if (tmp[carac_map[j]] = 1) then
      menu_asked[j,2] := true;
  end;
end;

procedure _check_avail_char;
var c, t, menu_pos, pers : byte;
begin
  for menu_pos :=1 to 26 do
  begin
    pergunta_get_ct(c, t, menu_pos);
    menu_asked[menu_pos,2] := true;

    for pers:=1 to 24 do
    begin
      if (board_mark[pers,2] = false) then
      begin
        if (lista_personagens[pers,c] = t) or ((c=11) and (lista_personagens[pers,c] = 3)) then
        begin
          menu_asked[menu_pos,2] := false;
          pers := 25;
        end;
      end;
    end;
  end;

  _remove_unique_chars;
end;

procedure _mark_pers_risk(pers : byte);
var x, y : byte;
begin
  board_mark[pers,2] := true;
  y := ((pers-1) div num_cartas_x)+1;
  x := pers - num_cartas_x*(y-1);
  screen_recover_cursor(x,y,2);
end;

procedure _mark_pers(menu_pos : byte; ans : boolean);
var c, t, i, x, y : byte;
    teste : boolean;
begin
  pergunta_get_ct(c, t, menu_pos);

  for i:=1 to 24 do
  begin
    teste := (lista_personagens[i,c] = t) = (not ans);
    if (c=11) and (lista_personagens[i,c] = 3) then
      teste := (not ans);

    if (teste) then
    begin
      y := ((i-1) div num_cartas_x)+1;
      x := i - num_cartas_x*(y-1);
      if (board_mark[i,2] = false) then
      begin
        board_mark[i,2] := true;
        cpu_pers := cpu_pers-1;
        screen_recover_cursor(x,y,2);
        delay(50);
      end;
    end;
  end;
end;

function _cpu_risk_pers : byte;
var pers : byte;
begin
  pers := random(24)+1;

  while (board_mark[pers,2] = true) do
    pers := (pers mod 24) + 1;

  _cpu_risk_pers := pers;
end;

procedure _ask_player(menu_pos : byte);
var ans : boolean;
    pers : byte;
begin
  pers := 1;

  if (menu_pos = 27) then
  begin
    pers := _cpu_risk_pers;
    ans := pers = pers_chosen[1];
    if (ans) then cpu_found:=true;
  end
  else
    ans := pergunta_sim(pers_chosen[1], menu_pos);

  screen_show_msg('O MSX pergunta:', pergunta_formula(pers,menu_pos));  
  delay(1000);

  if (ans=true) then
    screen_show_answer('Sim')
  else
    screen_show_answer('Nao');

  delay(500);

  if (menu_pos = 27) then
  begin
    if (ans=false) then
      _mark_pers_risk(pers);
  end
  else
    _mark_pers(menu_pos,ans);

  _check_avail_char;
end;

function _cpu_play_risk : boolean;
begin
  _cpu_play_risk := false;

  if (cpu_pers < 4) then
    _cpu_play_risk := true
  else
  begin
    if (cpu_pers < 13) then
       _cpu_play_risk := random(cpu_pers) < 2;
  end;
end;


{ Public }

function cpu_found_char : boolean;
begin
  cpu_found_char := cpu_found;
end;

function cpu_reveal : perg;
var s : string[1];
begin
  if (lista_personagens[pers_chosen[2],1] = 1) then s := 'a' else s := 'o';

  cpu_reveal := 'O meu personagem era ' + s + ' ' + lista_nomes[pers_chosen[2]];
end;

procedure cpu_play;
var menu_pos : byte;
    risk : boolean;
begin
  screen_restore_cards(2);
  randomize;
  risk := _cpu_play_risk;

{  screen_restore_menu(2);
  readln;}

  if (risk = false) then
  begin
    menu_pos := random(26);

    if (menu_asked[menu_pos,2] = true) then
      menu_pos:= get_menu_asked_next(menu_pos,2);
  end
  else
    menu_pos := 27;

  if (menu_pos < 27) then
    menu_asked[menu_pos,2] := true;
  _ask_player(menu_pos);
  readln;
end;

procedure cpu_choose_pers;
begin
  randomize;
  pers_chosen[2] := (random(240) div 10) + 1;
  screen_show_msg('O MSX joga:', 'Escolha um personagem ...');
  delay(500);
  screen_show_answer('Ok');
  readln;
end;

procedure cpu_reset;
begin
  cpu_found := false;
  cpu_pers := 24;
end;
