{ 
  -= Module PLAYER =-

  Project: CaraaraC 2
  Programmed by: Marcelo Silveira
  E-mail: flamar98@hotmail.com
  Date: November 2018
  License: GNU-GPL, v. 3.x

  Constantes e variáveis
  cursor_x, cursor_y - Coordenadas do cursor sobre os personagens na tela.
  ply_menu_i - Posição atual no menu gráfico.
  ply_found - Flag para determinar se o jogador ganhou o jogo.

  Procedures e Functions
  _get_pers_number - Retorna o número do personagem a partir do cursor da tela.
  _check_cursor_position - Verifica e corrige a posição do cursor sobre os personagens.
  _control_player_cursor - Controla a posição do cursor sobre os personagens.
  _control_player_cursor_menu - Controla a posição do cursor sobre o menu.
  _ask_cpu - Pergunta ao CPU.
  player_reveal - Revela o nome do personagem do jogador. Retorna string.
  player_found_char - Retorna se o jogador achou o personagem do CPU.
  player_play - Vez do jogador.
  player_choose_pers - Rotina para a escolha do personagem do jogador.
  player_init - Tarefas necessárias na inicialização desse módulo.
}

var cursor_x, cursor_y, ply_menu_i : byte;
    ply_found : boolean;

{ Private }

function _get_pers_number : byte;
begin
  _get_pers_number := cursor_x + (cursor_y-1)*num_cartas_x;
end;

procedure _check_cursor_position;
begin
  if (cursor_x>num_cartas_x) then cursor_x:=1;
  if (cursor_x<1) then cursor_x:=num_cartas_x;
  if (cursor_y>num_cartas_y) then cursor_y:=1;
  if (cursor_y<1) then cursor_y:=num_cartas_y;
end;

procedure _control_player_cursor;
var c : char;
begin
  c:=chr(0);

  while (ord(c) <> 13) do
  begin
    screen_draw_cursor(cursor_x, cursor_y, 1);
    screen_show_charac_info(_get_pers_number);
    read(KBD,c);
    screen_recover_cursor(cursor_x, cursor_y, 1);
    case ord(c) of
      28 : begin
             cursor_x:=cursor_x+1;
           end;
      29 : begin
             cursor_x:=cursor_x-1;
           end;
      30 : begin
             cursor_y:=cursor_y-1;
           end;
      31 : begin
             cursor_y:=cursor_y+1;
           end;
      32 : begin
             board_mark[_get_pers_number,1] := not board_mark[_get_pers_number,1];
             screen_recover_cursor(cursor_x, cursor_y, 1);
           end;
    end;
    _check_cursor_position;
  end;
  screen_clear_pers_info_scr;
end;

procedure _control_player_cursor_menu;
var c : char;
begin
  c:=chr(0);

  if (menu_asked[ply_menu_i,1]) then
    ply_menu_i := get_menu_asked_next(ply_menu_i,1);

  while (ord(c) <> 13) do
  begin
    screen_draw_cursor_menu(ply_menu_i);
    read(KBD,c);
    screen_recover_cursor_menu(ply_menu_i);
    case ord(c) of
      28 : begin
             ply_menu_i := get_menu_asked_next(ply_menu_i,1);
           end;
      29 : begin
             ply_menu_i := get_menu_asked_prev(ply_menu_i,1);
           end;
    end;
  end;
end;

procedure _ask_cpu;
var ans : boolean;
begin
  screen_show_msg('Voce pergunta:', pergunta_formula(_get_pers_number, ply_menu_i));
  delay(500);

  if (ply_menu_i = 27) then
  begin
    ans := _get_pers_number = pers_chosen[2];
    ply_found := ans;
  end
  else
    ans := pergunta_sim(pers_chosen[2], ply_menu_i);

  if (ans=true) then
    screen_show_answer('Sim')
  else
    screen_show_answer('Nao');
  readln;

  if (ply_found = false) then
    screen_restore_menu(1);
end;


{ Public }

function player_reveal : perg;
var s : string[1];
begin
  if (lista_personagens[pers_chosen[1],1] = 1) then s := 'a' else s := 'o';

  player_reveal := 'O seu personagem era ' + s + ' ' + lista_nomes[pers_chosen[1]];
end;

function player_found_char : boolean;
begin
  player_found_char := ply_found;
end;

procedure player_play;
begin
  screen_restore_cards(1);
  screen_restore_menu(1);

  repeat
    _control_player_cursor_menu;
    if (ply_menu_i = 28) then
      _control_player_cursor;
  until (ply_menu_i <> 28);

  if (ply_menu_i < 27) then
    menu_asked[ply_menu_i,1] := true
  else
    _control_player_cursor;

  _ask_cpu;
  if (ply_found = false) then
    _control_player_cursor;
end;

procedure player_choose_pers;
begin
  screen_show_msg('Voce joga:', 'Escolha um personagem');
  readln;

  screen_restore_menu(1);
  _control_player_cursor;

  pers_chosen[1] := _get_pers_number;
  screen_show_msg('Voce escolheu:', lista_nomes[pers_chosen[1]]);
  readln;
end;

procedure player_reset;
begin
  cursor_x := 1;
  cursor_y := 1;
  ply_menu_i := 1;
  ply_found := false;
end;

procedure player_init;
begin
  player_reset;
end;
