{ 
  -= Module SCREEN =-

  Project: CaraaraC 2
  Programmed by: Marcelo Silveira
  E-mail: flamar98@hotmail.com
  Date: November 2018
  License: GNU-GPL, v. 3.x

  Constantes e variáveis
  palette - Contém a paleta de cores da imagem do jogo.
  person_sel - Personagem selecionado na tela.

  Procedures e Functions
  _screen_load - Carrega a tela do jogo.
  _set_palette - Ajusta a paleta de cores da tela.
  _menu_gfx_mark_asked - Assinala no menu gráfico as perguntas já feitas pelo jogador.
  _menu_gfx_clear - Limpa a área do menu.
  _menu_gfx_restore - Restaura a área do menu.
  _print_justified - Imprime o texto com alinhamento justificado.
  screen_restore_menu - Restaura a área do menu (chamar esse).
  screen_show_msg - Mostra mensagem na tela. São possíveis 2 linhas de texto.
  screen_show_answer - Imprime a resposta do jogador ou CPU.
  screen_clear_pers_info_scr - Apaga área de informações abaixo do menu gráfico.
  screen_show_charac - Acende embaixo do menu gráfico as características do jogador corrente.
  screen_recover_cursor - Recupera área sob o cursor.
  screen_draw_cursor - Desenha o cursor.
  screen_restore_cards - Recupera todas as cartas. Usado para trocar as marcações dos jogadores.
  screen_copy_scr - Copia a tela da página 1 para a página 0.
  screen_init - Tarefas necessárias na inicialização desse módulo.
}

const palette : array[1..16,1..3] of byte = ((7,7,7),(6,6,5),(6,5,4),(5,4,4),
                                             (4,4,3),(3,2,2),(1,1,0),(2,3,3),
                                             (4,3,2),(5,4,2),(6,5,5),(6,5,3),
                                             (3,2,1),(6,2,5),(7,0,0),(0,0,7));

var person_sel : byte;


{ Private }

procedure _set_palette;
var i : byte;
begin
  for i:=1 to 16 do
    setpalette(i-1, palette[i,1], palette[i,2],  palette[i,3]); 
end;

procedure _screen_load;
begin
  {Filename, width, height, x, y, page, log_op, direction, screen_mode}
  LoadGraphic('CARA2.DAT',512,212,0,0,1,0,0,7);
  _set_palette;
end;

procedure _get_xy_menu(var xi, yi, xf, yf, i : integer);
begin
  xi := gfx_menu_entry_x[i]-1;
  yi := gfx_menu_y-1;
  xf := xi + gfx_menu_opt_width + 1;
  yf := yi + gfx_menu_opt_height + 1;
end;

procedure _get_xy(var xi, yi, xf, yf, x, y : integer);
begin
  xi := (x-1)*carta_width + (x-1)*carta_step_x;
  yi := (y-1)*carta_height + (y-1)*carta_step_y;
  xf := xi + carta_width - 2;
  yf := yi + carta_height - 1;
end;

procedure _menu_gfx_mark_asked(p : byte);
var xi, yi, xf, yf, i : integer;
begin
  for i:=1 to 26 do
  begin
    if (menu_asked[i,p] = true) then
    begin
      _get_xy_menu(xi, yi, xf, yf, i);
      line(xi+1, yi+1, xf-1, yf-1, 0, 14, 0);
      line(xi+1, yf-1, xf-1, yi+1, 0, 14, 0);
    end
  end;
end;

procedure _menu_gfx_clear;
begin
  line_bf(gfx_menu_bbox[1], gfx_menu_bbox[2], gfx_menu_bbox[3], gfx_menu_bbox[4], 0, 0);
end;

procedure _menu_gfx_restore;
var xi, yi, width, height : integer;
begin
  xi := gfx_menu_bbox[1];
  yi := gfx_menu_bbox[2];
  width := gfx_menu_bbox[3] - gfx_menu_bbox[1] + 1;
  height := gfx_menu_bbox[4] - gfx_menu_bbox[2] + 1;

  Copy_xy(xi, yi, 1, xi, yi, 0, width, height, 0);
end;

procedure _print_justified(msg : perg; y : integer);
var x : byte;
begin
  x := (512 - length(msg)*8) div 2;
  GraphicPrint(msg, x, y, 6, 0);
end;


{ Public }

procedure screen_show_msg(line1, line2 : perg);
begin
  _menu_gfx_clear;
  Color(6,0,0);
  _print_justified(line1, 185);
  _print_justified(line2, 194);
end;

procedure screen_show_answer(ans : perg);
begin
  Color(6,0,0);
  _print_justified(ans, 203);
end;

procedure screen_restore_menu(p : byte);
begin
  _menu_gfx_restore;
  _menu_gfx_mark_asked(p);
end;

procedure screen_clear_pers_info_scr;
begin
  line_bf(0,209,512,211,0,0);
end;

procedure screen_show_charac_info(pers : byte);
var xi, yi, xf, yf, i, c : integer;
begin
  setpalette(14,7,0,0);

  for i:=1 to 26 do
  begin
    if (pergunta_sim(pers, i) = true) then c:=14 else c:=0;
    _get_xy_menu(xi, yi, xf, yf, i);
    line_bf(xi+1,209,xf-1,211,c,0)
  end;
end;

procedure screen_recover_cursor_menu(i : integer);
var xi, yi, xf, yf : integer;
begin
  _get_xy_menu(xi, yi, xf, yf, i);
  line_b(xi,yi,xf,yf,6,0);
end;

procedure screen_draw_cursor_menu(i : integer);
var xi, yi, xf, yf : integer;
begin
  setpalette(15,7,7,0);
  _get_xy_menu(xi, yi, xf, yf, i);
  line_b(xi,yi,xf,yf,15,0);
end;

procedure screen_recover_cursor(x, y, p : integer);
var xi, yi, xf, yf : integer;
begin
  _get_xy(xi, yi, xf, yf, x, y);
  if (board_mark[x+(y-1)*num_cartas_x, p] = false) then
    Copy_xy(xi,yi,1,xi,yi,0,carta_width,carta_height,0)
  else
  begin
    line_bf(xi,yi,xf,yf,13+p,0);
    line_b(xi,yi,xf,yf,4,0);
  end;
end;

procedure screen_draw_cursor(x, y, p : integer);
var xi, yi, xf, yf : integer;
begin
  setpalette(15,0,0,7);
  _get_xy(xi, yi, xf, yf, x, y);
  line_b(xi,yi,xf,yf,15,0);
  line_b(xi+1,yi+1,xf-1,yf-1,15,0);
end;

procedure screen_restore_cards(p : byte);
var x, y : byte;
begin
  setpalette(14,7,0,0);
  setpalette(15,0,0,7);
  for y:=1 to num_cartas_y do
  begin
    for x:=1 to num_cartas_x do
      screen_recover_cursor(x,y,p);
  end;
end;

procedure screen_copy_scr;
begin
  {x, y, scr_page, dest_x, dest_y, dest_page, width, height, direction}
  Copy_xy(0,0,1,0,0,0,512,212,0);
end;

procedure screen_init;
begin
  Color(15,0,0);
  GraphicPrint('Carregando a tela ...',172,110,15,0);
  _screen_load;
  person_sel := 0;
end;
